/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
/*
 * Copyright (c) 2002-2010 Neterion, Inc.
 * All right Reserved.
 *
 * FileName :   vxgehal-nce.h
 *
 * Description:  NCE related include
 *
 * Created:       11 January 2006
 */

#ifndef	VXGE_HAL_NCE_H
#define	VXGE_HAL_NCE_H

__EXTERN_BEGIN_DECLS

vxge_hal_status_e
vxge_hal_nce_create(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_opaque_handle_t *opaque_handle,
	vxge_hal_opaque_handle_t *nce_opaque_handle,
	u64 src_mac_addr,
	u64 rem_mac_addr,
	u32 vlanId,
	u32 host_rch_time);

vxge_hal_status_e
vxge_hal_nce_delete(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle);

vxge_hal_status_e
vxge_hal_nce_update_mac_addr(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u64 mac_addr);

vxge_hal_status_e
vxge_hal_nce_update_rch_time(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u64 rch_time);

vxge_hal_status_e
vxge_hal_nce_query(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle);

__EXTERN_END_DECLS

#endif /* VXGE_HAL_NCE_H */
