/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
/*
 * Copyright (c) 2002-2010 Neterion, Inc.
 * All right Reserved.
 *
 * FileName :   vxgehal-pblist.h
 *
 * Description:  HAL HW PBLE List
 *
 * Created:       28 Jun 2006
 */
#ifndef	VXGE_HAL_PBLIST_H
#define	VXGE_HAL_PBLIST_H

__EXTERN_BEGIN_DECLS

typedef u64	__hal_pble_t;

u64
__hal_pblist_dma_addr_get(
	vxge_hal_pblist_t *pblist);

u32
__hal_pblist_length_get(
	vxge_hal_pblist_t *pblist,
	u32 num);

vxge_hal_status_e
vxge_hal_pblist_allocate(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_pblist_t *pblist,
	u32 length);

vxge_hal_status_e
vxge_hal_pblist_set(
	vxge_hal_pblist_t *pblist,
	u64	*phy_addr_list,
	u32 num_addr);

void vxge_hal_pblist_free(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_pblist_t *pblist);

__EXTERN_END_DECLS

#endif /* VXGE_HAL_PBLIST_H */
