/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
/*
 * Copyright (c) 2002-2010 Neterion, Inc.
 * All right Reserved.
 *
 * FileName :   vxgehal-stag.h
 *
 * Description:  stag related include
 *
 * Created:       11 January 2006
 */

#ifndef	VXGE_HAL_STAG_H
#define	VXGE_HAL_STAG_H

__EXTERN_BEGIN_DECLS

vxge_hal_status_e
vxge_hal_stag_allocate_nsmr(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u64 pd_id,
	u32 num_of_pbles,
	u32 stag_index,
	u32 remote_access_flag);

vxge_hal_status_e
vxge_hal_stag_allocate_mw(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 stag_index,
	u64 pd_id);

vxge_hal_status_e
vxge_hal_stag_deallocate(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 stag_index,
	u32 dealloc_pbl);

vxge_hal_status_e
vxge_hal_stag_register_nsmr(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	vxge_hal_stag_register_nsmr_params_t *params);

vxge_hal_status_e
vxge_hal_stag_re_register_nsmr(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	vxge_hal_stag_register_nsmr_params_t *params);

vxge_hal_status_e
vxge_hal_stag_register_smr(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 base_mr_stag_index,
	u32 va_base_flag,
	u32 remote_access_flag,
	u32 local_write_flag,
	u32 local_read_flag,
	u32 remote_write_flag,
	u32 remote_read_flag,
	u32 enable_mw_binding_flag,
	u32 stag_index,
	u32 stag_key,
	u64 pd_id,
	u64 base_to);

vxge_hal_status_e
vxge_hal_stag_query(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 stag_index);

vxge_hal_status_e
vxge_hal_stag_validate(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 stag_index,
	u32 stag_key);

vxge_hal_status_e
vxge_hal_stag_invalidate(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 stag_index,
	u32 stag_key,
	u64 pd_id);

vxge_hal_status_e
vxge_hal_stag_bind_mw(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 mr_stag_index,
	u32 mr_stag_key,
	u32 mw_stag_index,
	u32 mw_stag_key,
	u32 mr_stag,
	u32 mw_ctrl,
	u64 mw_length,
	u64 tagged_offset);

vxge_hal_status_e
vxge_hal_stag_fast_register_nsmr(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 mr_control_size,
	u64 mr_control_ptr);

__EXTERN_END_DECLS

#endif /* VXGE_HAL_STAG_H */
