/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
/*
 * Copyright (c) 2002-2010 Neterion, Inc.
 * All right Reserved.
 *
 * FileName :   vxgehal-tcp.h
 *
 * Description:  TCP offload related include
 *
 * Created:       11 January 2006
 */
#ifndef	VXGE_HAL_TCP_H
#define	VXGE_HAL_TCP_H

__EXTERN_BEGIN_DECLS

vxge_hal_status_e
vxge_hal_tcp_open(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_opaque_handle_t *opaque_handle,
	vxge_hal_opaque_handle_t *session_opaque_handle,
	vxge_hal_tcp_open_params_t *params);

vxge_hal_status_e
vxge_hal_tcp_promote_to_iwarp(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	vxge_hal_tcp_promote_to_iwarp_params_t *params);

vxge_hal_status_e
vxge_hal_tcp_modify(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 mpa_crc_valid,
	u32 tx_marker_mode,
	u32 rx_marker_mode,
	u32 rdmap_version,
	u32 ddp_version,
	u32 iwarp_qp_limit_armed,
	u32 iwarp_qp_limit_value,
	u32 rq_max_length,
	u32 block_permissions,
	u32 ird_limit);

vxge_hal_status_e
vxge_hal_tcp_delete(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle);

vxge_hal_status_e
vxge_hal_tcp_abort(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle);

vxge_hal_status_e
vxge_hal_tcp_update_rxwin(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 rcv_buf,
	u32 rcv_buf_size,
	u32 rcv_max_wnd);

vxge_hal_status_e
vxge_hal_tcp_update_mss(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 snd_mss,
	u32 snd_msss_limit);

vxge_hal_status_e
vxge_hal_tcp_update_ip_header(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 ip_tos,
	u32 ip_flowlabel);

vxge_hal_status_e
vxge_hal_tcp_update_keepalive(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 kpa_ok,
	u32 probes_max,
	u32 idle_time,
	u32 retry_time);

vxge_hal_status_e
vxge_hal_tcp_relink_to_nce(
	vxge_hal_vpath_h vpath_handle,
	vxge_hal_obj_id_t obj_id,
	vxge_hal_opaque_handle_t *opaque_handle,
	u32 nce_id);

__EXTERN_END_DECLS

#endif /* VXGE_HAL_TCP_H */
