/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
/*
 * Copyright (c) 2002-2010 Neterion, Inc.
 * All right Reserved.
 *
 * FileName :   vxgehal.h
 *
 * Description:  Consolidated header for hal.
 *
 * Created:       20 December 2005
 */

#ifndef	VXGEHAL_H
#define	VXGEHAL_H


#include "vxgehal-ll.h"
#include "vxgehal-debug.h"
#include "vxgehal-regdefs.h"
#include "vxgehal-legacy-reg.h"
#include "vxgehal-toc-reg.h"
#include "vxgehal-common-reg.h"
#include "vxgehal-memrepair-reg.h"
#include "vxgehal-pcicfgmgmt-reg.h"
#include "vxgehal-mrpcim-reg.h"
#include "vxgehal-srpcim-reg.h"
#include "vxgehal-vpmgmt-reg.h"
#include "vxgehal-vpath-reg.h"
#include "vxgehal-regs.h"
#include "vxgehal-config-priv.h"
#include "vxgehal-swapper.h"
#include "vxgehal-mm.h"

#ifdef	VXGE_HAL_TITAN_2
#include "vxgehal-bitmap.h"
#include "vxgehal-regpool.h"
#include "vxgehal-lbwrapper.h"
#endif  /* VXGE_HAL_TITAN_2 */

#include "vxgehal-blockpool.h"
#include "vxgehal-doorbells.h"
#include "vxgehal-virtualpath.h"
#include "vxgehal-device.h"
#include "vxgehal-channel.h"
#include "vxgehal-srpcim.h"
#include "vxgehal-mrpcim.h"
#include "vxgehal-driver.h"
#include "vxgehal-ring.h"
#include "vxgehal-fifo.h"
#include "vxgehal-ifmsg.h"
#include "vxgehal-lro.h"

#ifdef	VXGE_HAL_TITAN_2

#include "vxgehal-rnic.h"
#include "vxgehal-message.h"
#include "vxgehal-odlist.h"
#include "vxgehal-pblist.h"
#include "vxgehal-offload.h"
#include "vxgehal-sq.h"
#include "vxgehal-srq.h"
#include "vxgehal-cqrq.h"
#include "vxgehal-umq.h"
#include "vxgehal-dmq.h"
#include "vxgehal-nce.h"
#include "vxgehal-stag.h"
#include "vxgehal-tcp.h"
#include "vxgehal-spdm.h"
#include "vxgehal-session.h"

#endif  /* VXGE_HAL_TITAN_2 */

#endif /* VXGEHAL_H */
